package Modules::BannerAd;
use strict;
use ExSite::Config;
use ExSite::Misc;
use ExSite::Input;
use ExSite::Image;
use ExSite::Util;
use Modules::BaseDCD;
use MIME::Base64;

use base qw (Modules::BaseDCD);

#---------------------------------------------------------------------
sub ioctl{
	my $this = shift;
	$_ = shift;   # $_ is the ioctl request
	if (/ModuleName/){
		return "Advertising";
	}elsif (/ControlPanel/){
		return \&control_panel;
	}elsif (/ModuleInfo/){
        	return "The Advertising module serves banner ads to websites, 
tracks advertising clicks, and monitors balances on pay-per-view or 
pay-per-click campaigns.";
	}elsif (/isRestricted/){
		return 1;
	}
	elsif (/DynContentParameter/) {
	    my %format = %{$this->format()};
	    my $out = "<p><b>Format:</b>
<select name=\"param\">
<option value=\"\">(default)</option>\n";
	    foreach my $format (values %format) {
		$out .= "<option value=\"format=$format->{name}\">$format->{name}</option>\n";
	    }
	    $out .= "</select></p>\n";
	    return $out;
	}
	elsif (/Publish/){
                return \&publish;
	}
	elsif (/Cron/){
		return \&cron;
	}
	return;
}
sub write{
	my ($this,$options) = @_;
	my  %opt = &DecodeString($options);
	my $action = $this->{input}{action} || $opt{action};
	# Run the plugin in ajax mode
	if ($share{Page}){
		if ($share{Page}->is_publishing()){
			my $ml = $this->ml();
			my $_num = int(rand(100000));
			my $_js ="document.write(getRequestDataAsync('$config{server}{server}$config{server}{CGIpath}/dcd.cgi/BannerAd?_opt=$options&_ref=".&url_escape($this->link())."','BannerAd${_num}'));";
			return $ml->script(undef,{src=>"$config{server}{server}$config{server}{HTMLpath}/_ExSite/js/httprequest.js"}).$ml->div($ml->script($_js),{id=>"BannerAd${_num}"});
		}
	}
	# Process click through
	if ($this->{input}{bannerad_id}){
		return $this->processBannerClick($this->{input}{bannerad_id});
	}
	# Display banners
	else{
		return $this->displayBanner($opt{format},$opt{count});
	}
	return undef;
}
#---------------------------------------------------------------------
# Control panel
sub control_panel{
	my $this = shift;
	my $out;
	my $action = $this->{input}{action};
	my $sectionid = exists $this->{input}{section_id} ? $this->{input}{section_id} : 0;
	my $banneradid = $this->{input}{bannerad_id};
	my $formatid = $this->{input}{format_id} || 0;
	if ($action eq "view_report" && $banneradid){
		$out .= $this->viewReport($banneradid,$this->{input});
	}
	elsif ($action eq "publish" && $sectionid){
		$out = $this->publish($sectionid);
	}
	# Add a new banner ad
	elsif($action eq "new_bannerad"){
	    $out = $this->newBanner($sectionid);
	}
	# Delete a banner ad
	elsif($action eq "delete_bannerad" && $banneradid){
	    $out = $this->deleteBanner($banneradid);
	}
	# Edit a banner ad
	elsif($action eq "edit_bannerad" && $banneradid){
	    $out = $this->editBanner($banneradid,$sectionid);
	}
	# View banner ad details
	elsif($action eq "detail_bannerad" && $banneradid){
	    $out = $this->detailBanner($banneradid);
	}
	# Copy banner ad
	elsif ($action eq "copy_bannerad" && $banneradid){
	    $out = $this->copyBanner($banneradid);
	}
	# View/export banner click through log to excel
	elsif ($action =~ /^(view|export)_log$/ && $banneradid){
		$out .= $this->reportLog($action,$banneradid,$this->{input});
	}
	# Add a new format
	elsif($action eq "new_format") {
	    $out = $this->newFormat($sectionid);
	}
	# Delete a banner ad
	elsif($action eq "delete_format") {
	    $out = $this->deleteFormat($formatid);
	}
	# Edit a banner ad
	elsif($action eq "edit_format") {
	    $out = $this->editFormat($formatid,$sectionid);
	}
	# View summary reports
	else{
	    $out = $this->viewSummary($sectionid);
	}
	return $out;
}
#---------------------------------------------------------------------

sub cron{
	my ($this) = @_;
	my $log_file = $config{BannerAd}{apache_log};
	if (!-e $log_file){
		return;
	}
	$this->time()->set();
	$this->time()->add(-1,"days");
	# Last yesterday's stats
	my $logging_date = $this->time()->write("sql_date");
	my %m_table = (
		Jan=>1,
		Feb=>2,
		Mar=>3,
		Apr=>4,
		May=>5,
		Jun=>6,
		Jul=>7,
		Aug=>8,
		Sep=>9,
		Oct=>10,
		Nov=>11,
		Dec=>12
	);
	my @banners = $this->{db}->fetch_all("bannerad");
	my %banner_table = map {$_->{bannerad_id}=>$_} @banners;
	my %bin;
	open LOG, $log_file;
	while (my $line = <LOG>){
		# look for banner ads in the log
		if ($line =~ /\[(\d{2})\/(\w{3})\/(\d{4}):.* "GET .*\/BannerAd\/img\/.+\/(\d+).+\.\w{3} HTTP/i){
			my $day = $1;
			my $month = sprintf ("%02d",$m_table{$2});
			my $year = $3;
			my $bid = $4;
			my $ad_type = $banner_table{$bid}{bannerad_type};
			my $log_on = $banner_table{$bid}{logging} =~ /on/i ? 1 : 0;
			my $log_date = sprintf("%04d-%02d-%02d",$year,$month,$day);
			next if ($log_date ne $logging_date);
			$bin{$log_date}{$bid}{count} += 1;
		}
	}
	close LOG;
	foreach my $date(keys %bin){
		foreach my $bannerid(keys %{$bin{$date}}){
			my %banner = $this->{db}->fetch("bannerad",$bannerid);
			# Add log entry
			$this->trackDaily(\%banner,$bin{$date}{$bannerid}{count},$date." 11:59:59")
		}
	}
	return;
}
#---------------------------------------------------------------------
sub icon{
	my ($this,$type) = @_;
	my %icon = (
		excel=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/excel.png",
		edit=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/edit.png",
		delete=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/delete.png",
		new=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/new.png",
		view=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/view.png",
		publish=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/publish.png",
		report=>"$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/report.png",
	);
	return exists $icon{$type} ? $icon{$type} : "";
}
sub setup{
	my ($this) = @_;
	my %sql_query = (
		"global banner"=>{sql=>"select * from bannerad where section_id = 0 || section_id is null or section_id = ''",nparam=>0,mode=>"r",keys=>"bannerad"},
		"summary report"=>{sql=>"select substring(bannerad_log.time,1,7) as date,bannerad_log.type as type,bannerad_log.count as count from bannerad_log where bannerad_log.bannerad_id = ?",nparam=>1,mode=>"r",keys=>"bannerad_log"},
		"log report"=>{sql=>"select * from bannerad_log where bannerad_id = ? and time like ? order by bannerad_log_id asc",nparam=>2,mode=>"r",keys=>"bannerad_log"},
		"active banners"=>{sql=>"select * from bannerad where status = 'active' and (section_id = ? or section_id=0)",nparam=>1,mode=>"r",keys=>"bannerad"},
	);
	foreach my $key (keys %sql_query){
		$share{DB}->set_query($key,%{$sql_query{$key}});
	}
	$this->{db} = $share{DB};
	return;
}
# Publish banner
sub publish{
	my ($this) = @_;
	my $sectionid = $this->{input}{section_id} || 0;
	my @log;
	my @banners;
	if ($sectionid > 0){
		@banners = $this->fetchBannerad($sectionid);
	}else{
		# Publish global banners
		@banners = $this->{db}->get_query("global banner");
	}
	if (scalar(@banners) <= 0){
		return $this->ml()->p("No banners found");
	}
	my $disk_path = $this->getBannerDiskPath($sectionid);
	if (!$disk_path){
		return $this->ml()->p("Unable to create directory for image publishing");
	}
	foreach my $banner(@banners){
		my $filename = $this->getBannerFilename($banner);
		if (ExSite::Misc::is_tainted($filename)){
			$filename =~ /^([a-zA-Z0-9_-]+\.[a-zA-Z0-9_-]+)$/;
			$filename = $1;
		}
		my $write_file = $disk_path."/".$filename;
		if (open(OFILE,">$write_file")){
			my $file_content = $this->getBannerData($banner);
			print OFILE $file_content;
			close OFILE;
			push(@log,"Write File... $filename");
		}else{
			push(@log,$this->ml()->span("FAILED: $!",{class=>"error"}));
		}
	}
	return join("\n",map {$this->ml()->p($_)} @log);
}
sub getNullGraphic{
	my ($this) = @_;
	if (!$this->{null_graphic}){
		my $_fdata;
		my $_size = 0;
		my $_continue = 1;
		open FILE, "$config{server}{HTMLroot}$config{server}{HTMLpath}/_Modules/BannerAd/null.gif";
		while($_continue){
			$_continue = read(FILE,$_fdata,1024,$_size);
			$_size += $_continue;
		}
		close FILE;
		$this->{null_graphic} = $_fdata;
	}
	return $this->{null_graphic};
}
# Decode banner data
sub getBannerData{
	my ($this,$banner_rec) = @_;
	my $fdata = $banner_rec->{fdata};
	if (!$fdata){
		return $this->getNullGraphic();
	}
	my $img = new ExSite::Image($fdata);
	return $img->get();
}
# Get banner html path
sub getBannerWebPath{
	my ($this,$sectionid) = @_;
	$sectionid = $sectionid || 0;
	return "$config{server}{server}$config{server}{HTMLpath}/_Modules/BannerAd/img/$sectionid";
}
# Check and create directory for publishing
sub checkDiskDir{
	my ($this,$dir) = @_;
	if (!$dir){
		return 0;
	}
	my $checked = $dir;
	if (ExSite::Misc::is_tainted($dir)){
		$dir =~ /^((\/{1}[a-zA-Z0-9_-]+)+)$/;
		$checked = $1;
	}
	if (! -e $checked){
		if (!mkdir($checked)){
			return 0;
		}
	}
	return 1;
}
# Get banner publishing disk path
sub getBannerDiskPath{
	my ($this,$sectionid) = @_;
	$sectionid = $sectionid || 0;
	my $module_path = "$config{server}{HTMLroot}$config{server}{HTMLpath}/_Modules/BannerAd/img";
	if (!$this->checkDiskDir($module_path)){
		return "";
	}
	my $disk_path = "$module_path/$sectionid";
	if (!$this->checkDiskDir($disk_path)){
		return "";
	}
	# Tainted check
	my $checked;
	$disk_path =~ /^((\/{1}[a-zA-Z0-9_-]+)+)$/;
	my $checked = $1;
	return $checked;
}
# Get banner filename
sub getBannerFilename{
	my ($this,$banner_rec) = @_;
	my $bannerid = $banner_rec->{bannerad_id};
	if ($banner_rec->{fdata}) {
	    my $img = new ExSite::Image($banner_rec->{fdata});
	    return $bannerid."_".&clean_filename($img->name);
	}
	return $bannerid."_img.gif";
}
# Get banner url
sub getBannerUrl{
	my ($this,$banner_rec) = @_;
	my $sectionid = $banner_rec->{section_id};
	my $filename = $this->getBannerFilename($banner_rec);
	my $path = $this->getBannerDiskPath($sectionid);
	my $diskpath = $path."/".$filename;
	if (-e $diskpath){
		my $serverpath = $this->getBannerWebPath($sectionid);
		return $serverpath."/".$filename;
	}
	# Banner isn't published
	return "";
}
# Get banner img html tag
sub getBannerHTML{
	my ($this,$banner_rec) = @_;
	my $banner_url = $this->getBannerUrl($banner_rec);
	if ($banner_url){
		return $this->ml()->img(undef,{src=>$banner_url,border=>0});
	}
	# Banner isn't published. Use getdata.cgi
	return $this->{db}->show_data("bannerad","fdata",$banner_rec->{fdata},$banner_rec->{bannerad_id});
}
# Get publish url for bannerad control panel
sub publish_url{
	my ($this,$sectionid) = @_;
	return "$config{server}{server}$config{server}{CGIpath}/publish.cgi?module=BannerAd&section_id=$sectionid";
}
#----------------------------------------------------------------------
# Summary report
sub viewSummary{
	my ($this,$sectionid) = @_;
	my @sites = $this->{db}->my_real_sites();
	my @licensed_sites;
	foreach my $site (@sites) {
	    if ($this->site_license($site->{section_id})) {
		push @licensed_sites,$site;
	    }
	}
	if (@licensed_sites == 0) {
	    return $this->warn("None of your sites are licensed to use the Advertising plug-in.");
	}

	my $sid = @licensed_sites==1 ? 
	    $licensed_sites[0]{section_id} : 
	    $this->{input}{section_id};
	my $out;
	if (@licensed_sites > 1) {
	    $out .= "<p><form method=\"GET\">Select website: <select name=\"section_id\" onchange=\"document.forms[0].submit()\">\n<option value=\"0\">== choose a site ==</option>\n";
	    foreach my $s (@licensed_sites) {
		$out .= "<option value=\"$s->{section_id}\"";
		$out .= " selected" if ($s->{section_id} == $sid);
		$out .= ">$s->{title}</option>\n";
	    }
	    $out .= "</select></form>\n";
	}
	if (scalar(@sites) > 1){
		$out .= $this->viewBannerReport({section_id=>0})."<br>\n";
	}

	if ($sid) {
	    my %s = &keywise("section_id",\@licensed_sites);
	    $out .= $this->viewBannerReport($s{$sid})."<br>\n";
	}

	$out .= $this->viewFormatReport($sectionid)."<br>\n";
	return $out;
}
# Add a new banner ad
sub newBanner{
	my ($this,$sectionid) = @_;
	return $this->form_bannerad({label=>"New Banner",section_id=>$sectionid});	
}
# Edit a banner ad
sub editBanner{
	my ($this,$banneradid,$sectionid) = @_;
	return $this->form_bannerad({label=>"Edit Banner",section_id=>$sectionid,bannerad_id=>$banneradid});	
}
# Banner form
sub form_bannerad{
	my ($this,$opt) = @_;
	my $label = $opt->{label};
	my $sectionid = $opt->{section_id};
	my $banneradid = $opt->{bannerad_id};
	# Set options to generate the form
	my %form_option = (
		table=>"bannerad",
		hide=>["section_id"],
		extra=>{
			reply=>$this->link(action=>undef,bannerad_id=>undef,__plaintext=>1),
		},
	);
	if ($banneradid){
		# Add record id for editing a banner
		$form_option{record} = $banneradid;
	}else{
		# Add section id for inserting a new banner
		$form_option{data}{section_id} = $sectionid || 0;
	}
	my $form = $this->{db}->make(%form_option);
	return $this->ml()->h1($label).$form;
}
# Add a new banner ad
sub newFormat{
	my ($this,$sectionid) = @_;
	return $this->form_format({label=>"New Format",section_id=>$sectionid});
}

# Edit a banner ad
sub editFormat{
	my ($this,$formatid,$sectionid) = @_;
	return $this->form_format({label=>"Edit Format",section_id=>$sectionid,format_id=>$formatid});
}
# Banner format form
sub form_format{
	my ($this,$opt) = @_;
	my $label = $opt->{label};
	my $sectionid = $opt->{section_id} || 0;
	my $formatid = $opt->{format_id} || 0;
	# Set options to generate the form
	my %form_option = (
		table=>"bannerad_format",
		extra=>{
			reply=>$this->link(action=>undef,format_id=>undef,__plaintext=>1),
		},
	);
	if ($formatid){
		# Add record id for editing a banner
		$form_option{record} = $formatid;
	}
	my $form = $this->{db}->make(%form_option);
	return $this->ml()->h1($label).$form;
}
sub back_link{
	my ($this,$url) = @_;
	return $url ? $this->ml()->p($this->ml()->a("&lt;&lt; Back",{href=>$url})) : "";
}
# Tracking report
sub viewReport{
	my ($this,$banneradid,$in) = @_;
	return $this->ml()->p("Invalid banner") if !$banneradid;
	my %banner = $this->{db}->fetch("bannerad",$banneradid);
	my @recs = $this->{db}->get_query("summary report",$banneradid);
	my %bin;
	foreach my $rec(@recs){
		$bin{$rec->{date}}{$rec->{type}} += $rec->{count} || 0;
	}
	my @months = qw(January February March April May June July August September October November December);
	my @rdata;
	foreach my $mon(sort {$b cmp $a} keys(%bin)){
		my $col_month = $this->ml()->a($months[int(substr($mon,5,2)) - 1]." ".substr($mon,0,4),{href=>$this->link(action=>"view_log",bannerad_id=>$banneradid,month=>$mon,reply=>&url_escape($this->link(__plaintext=>1)))});
		my $track_impression = !$config{BannerAd}{log}{$banner{bannerad_type}}{impression} && !$config{BannerAd}{log}{$banner{bannerad_type}}{'daily impression'} ? 0 : 1;
		my $track_click = $config{BannerAd}{log}{$banner{bannerad_type}}{click} ? 1 : 0;
		my $show_impress = "?";
		my $show_click = "?";
		my $show_conv = "?";
		# Calculate conversion rate
		if ($track_impression || $track_click){
			my $col_impress;
			my $col_click;
			if ($track_impression){
				$col_impress = ($config{BannerAd}{log}{$banner{bannerad_type}}{impression} ? $bin{$mon}{impression} : $bin{$mon}{'daily impression'}) || "0";
				$show_impress = $col_impress;
			}
			if ($track_click){
				$col_click = $bin{$mon}{click} || 0;
				$show_click = $col_click;
			}
			if ($track_impression && $track_click){
				my $col_conv = sprintf("%d\%",$col_impress ? int($col_click) / int($col_impress) * 100 :  0);
				$show_conv = $col_conv;
			}
		}
		push(@rdata,[$col_month,$show_impress,$show_click,$show_conv]);
	}
	my %lreport = (
		title=>"Summary Report",
		headers=>["Month","Impressions","Clicks","Conversion %"],
		data=>\@rdata,
	);
	return $this->back_link(&url_unescape($in->{reply})).$this->report(\%lreport);
}
sub reportLog{
	my ($this,$action,$banneradid,$in) = @_;
	my $export_mode = $action =~ /export/i ? 1 : 0;
	# Click through report
	#
	# Fetch the logs
	my @recs;
	my $report_date = "";
	if ($in->{month} =~ /\d{4}-\d{2}/){
		@recs = $this->{db}->get_query("log report",$banneradid,"$in->{month}%");
		$this->time()->set("sql_date",$in->{month}."-01");
		$report_date = $this->time()->write("month_long")." ".$this->time()->write("year");
	}else{
		@recs = $this->{db}->fetch_match("bannerad_log",{bannerad_id=>$banneradid},"bannerad_log_id asc");
	}
	my @logs = map { Modules::BannerAd::Log->new(data=>$_) || () }@recs;
	my $L = new Modules::BannerAd::Log();
	my @columns = qw(time viewer_ip referrer count type);
	# Report heading
	my @lheader = map {$L->label($_)} @columns;
	my @ldata;
	my $_mode = "report";
	my $_showdata = "showdata";
	if ($export_mode){
		$_mode = "export";
		$_showdata = "getdata_excel";
	}
	foreach my $log(@logs){
		my @row_data = map { $log->$_showdata($_) } @columns;
		# Gather data
		push(@ldata,\@row_data);
	}
	my %banner = $this->{db}->fetch("bannerad",$banneradid);
	$this->time()->set();
	my %lreport = (
		title=>($report_date || "")." Report for $banner{url} - created on ".$this->time()->write("full"),
		headers=>\@lheader,
		data=>\@ldata,
		tools=>$this->ml()->a($this->ml()->img(undef,{src=>$this->icon("excel"),border=>0}),{href=>$this->link(bannerad_id=>$banneradid,action=>"export_log",reply=>undef)})
	);
	if ($export_mode){
		print "content-type: application/vnd.ms-excel\ncontent-disposition: attachment; filename=banner_report.xls\n\n";
	}
	return (!$export_mode ? $this->back_link(&url_unescape($in->{reply})) : "").$this->$_mode(\%lreport);
}
# View banner details
sub detailBanner{
	my ($this,$banneradid) = @_;
	my $foot;
	# Banner details report
	#
	# Fetch the banner ad
	my %ad = $this->{db}->fetch("bannerad",$banneradid);
	# Define column heading
	my @header = ("Ad link","Image","Link text","Description text","Type",
		"Cost per view/click","Enable logging","Total remaining value of views/clicks","Priority to be given to this ad",
		"Date to stop showing timed ads","Status");
	my @header_col = ("url","fdata","adata","ddata","bannerad_type","rate","logging","balance","weight","expiry_date","status");
	my @data;
	# Only display the columns defined in @header_col
	foreach my $col(@header_col){
		# format data
		push(@data,$this->{db}->show_data("bannerad",$col,$ad{$col},$ad{bannerad_id}));
	}
	# Define options link info
	my @options = (
		{
			id=>"edit",label=>"Edit",
			url=>$this->link(action=>"edit_bannerad",banner_id=>$ad{bannerad_id}),
			img=>$this->icon("edit"),
		},
		{
			id=>"delete",label=>"Delete",
			url=>"javascript:deleteConfirm($ad{bannerad_id})",
			img=>$this->icon("delete"),
		},
	);
	# Options links(edit and delete commands)
	my @links = map {$this->ml()->a($this->ml()->img(undef,{src=>$_->{img},border=>0,title=>$_->{label},alt=>$_->{label}}),{href=>$_->{url}})} @options;
	my %report = (
		title=>"Banner Ad",
		headers=>\@header,
		data=>\@data,
		tools=>join("",@links),
		foot=>$foot,
	);
	return $this->javascript().$this->ml()->h1("View Details").$this->report(\%report);
}
# Delete a banner ad
sub deleteBanner{
	my ($this,$banneradid) = @_;
	return if !$banneradid;
	my %banner = $this->{db}->fetch("bannerad",$banneradid);
	$this->{db}->trash_r("bannerad",$banneradid);
	$this->redirect($this->link(bannerad_id=>undef,action=>undef,__plaintext=>1));
	return;
}
# Delete a banner ad
sub deleteFormat{
	my ($this,$formatid) = @_;
	return if !$formatid;
	$this->{db}->trash_r("bannerad_format",$formatid);
	$this->redirect($this->link(action=>undef,format_id=>undef,__plaintext=>1));
	return;
}
# Copy a banner ad
sub copyBanner{
	my ($this,$banneradid) = @_;
	my %bannerad = $this->{db}->fetch("bannerad",$banneradid);
	# Remove bannerad_id(primary key)
	delete $bannerad{bannerad_id};
	# Set the balance to 0
	$bannerad{balance} = 0;
	$this->{db}->insert("bannerad",\%bannerad);
	$this->redirect($this->link(action=>undef,bannerad_id=>undef,__plaintext=>1));
	return;
}
# Fetch banner ads
sub fetchBannerad{
	my ($this,$sectionid) = @_;
	if (! $sectionid) { $sectionid = 0; }
	return $this->{db}->fetch_child("bannerad","section",$sectionid);
}

sub format{
	my ($this,$type) = @_;
	if (ref($this->{banner_format}) !~ /hash/i){
		my @formats = $this->{db}->fetch_all("bannerad_format");
		my %formats = &keywise("bannerad_format_id",\@formats);
		$this->{banner_format} = \%formats;
	}
	return $type ?  $this->{banner_format}{$type} || "" : $this->{banner_format}  || {};
}
# Format report
sub viewFormatReport{
	my ($this,$sectionid) = @_;
	# Fetch formats
	my $ml = $this->ml();
	# Report heading
	my @header = ("Format","Width","Height","Options");
	my @data;
	my %format = %{$this->format()};
	foreach my $f (values %format) {
	        next if (scalar keys %$f == 0);
		# Create option links
		my $edurl = $this->link(action=>"edit_format",format_id=>$f->{bannerad_format_id});
		my $delurl = $this->link(action=>"delete_format",format_id=>$f->{bannerad_format_id});
		my $option = $ml->a($ml->img(undef,{src=>$this->icon("edit"),border=>0}),{href=>$edurl}).$ml->a($ml->img(undef,{src=>$this->icon("delete"),border=>0}),{href=>"javascript:if(confirm('Are you sure you want to delete this banner format?')){location.href='$delurl';}"});
		# Gather and format data
		push(@data,[$f->{name},$f->{width},$f->{height},$ml->div($option,{style=>"text-align:right;"})]);
	}
	# Tool links
	my $tool = $ml->a($ml->img(undef,{src=>$this->icon("new"),border=>0,title=>"New Format",alt=>"New Format"}),{href=>$this->link(action=>"new_format")});
	my %report = (
		title=>"Ad Formats",
		headers=>\@header,
		data=>\@data,
		tools=>$tool,
	);
	return $this->javascript().$this->report(\%report);
}

# Summary report
sub viewBannerReport{
	my ($this,$section) = @_;
	my $sectionid = $section->{section_id};
	# Fetch banner ads
	my @banners = $this->fetchBannerad($sectionid);
	# Report heading
	my @header = ("Format","Status","Type","Weight","Expiry Date","Ad link","Style","Logging","Rate","Balance","Options");
	my @data;
	foreach my $banner(@banners){
		my $bannerid = $banner->{bannerad_id};
		# Define option link info
		my @options = (
		{
			id=>"detail",label=>"View Details",
			url=>$this->link(action=>"detail_bannerad",bannerad_id=>$bannerid),
			img=>$this->icon("view"),
		},
		{
			id=>"edit",label=>"Edit",
			url=>$this->link(action=>"edit_bannerad",bannerad_id=>$bannerid),
			img=>$this->icon("edit"),
		},,
		{
			id=>"delete",label=>"Delete",
			url=>"javascript:deleteConfirm($bannerid)",
			img=>$this->icon("delete")
		},
		);
		unshift @options, {
			id=>"report",label=>"View Report",
			url=>$this->link(action=>"view_report",bannerad_id=>$bannerid,reply=>&url_escape($this->link(__plaintext=>1))),
			img=>$this->icon("report"),
		} if $banner->{logging} =~ /on/;
		my @links = map {$this->ml()->a($this->ml()->img(undef,{src=>$_->{img},border=>0,title=>$_->{label},alt=>$_->{label}}),{href=>$_->{url}})} @options;
		# Gather and format data
		push(@data,[
			    $this->format($banner->{format})->{name},
			    $this->displayStatus($banner),
			    $banner->{bannerad_type},
			    $banner->{weight},
			    $this->{db}->show_data("bannerad","expiry_date",$banner->{expiry_date},$banner->{bannerad_id}),
			    $this->{db}->show_data("bannerad","url",$banner->{url},$banner->{bannerad_id}),			
			    $banner->{fdata} ? "image" : "text",
			    $banner->{logging},			
			    $this->{db}->show_data("bannerad","rate",$banner->{rate},$banner->{bannerad_id}),
			    $this->{db}->show_data("bannerad","balance",$banner->{balance},$banner->{bannerad_id}),
			    $this->ml()->div(join("",@links),{style=>"text-align:right;"}),
		]);
	}
	# Tool links
	my %report = (
		title=>$section->{title} || "Ads for all sites",
		headers=>\@header,
		data=>\@data,
		tools=>$this->ml()->a($this->ml()->img(undef,{src=>$this->icon("publish"),border=>0}),{href=>$this->publish_url($sectionid),target=>"_blank"}).$this->ml()->a($this->ml()->img(undef,{src=>$this->icon("new"),border=>0,title=>"New Banner",alt=>"New Banner"}),{href=>$this->link(action=>"new_bannerad",section_id=>$sectionid)}),
	);
	return $this->javascript().$this->report(\%report);
}
# Display the status column on the summary report
sub displayStatus{
	my ($this,$bannerad) = @_;
	my @status;
	# Default status(active or inactive)
	push(@status,$bannerad->{status});
	if ($this->isExpired($bannerad)){
		# expired banner ad
		push(@status,"expired");
	}
	if ($this->isExhausted($bannerad)){
		# exhausted banner ad
		push(@status,"exhausted");
	}
	return join(", ",@status);
}
# Is the banner ad exhausted?
sub isExhausted{
	my ($this,$bannerad) = @_;
	# Only check the pay-per-view or pay-per-click ads
	return 0 if $bannerad->{bannerad_type} !~ /pay/i;
	# Funds available
	return 0 if $bannerad->{balance} > 0;
	return 1;
}
sub CompareToNow{
	my ($this,$t1) = @_;
	return $this->time()->compare($t1,"sql_date");	
}
# Is the banner ad expired?
sub isExpired{
	my ($this,$bannerad) = @_;
	# Only check the timed ads
	return 0 if $bannerad->{bannerad_type} !~ /timed/i;
	# The ad is expired
	return 1 if ($this->CompareToNow($bannerad->{expiry_date}) < 0);
	return 0;
}
# Is the ad active?
sub isActive{
	my ($this,$bannerad) = @_;
	# The ad is considered active when it is not:
	# - expired
	# - exhausted
	return 1 if (!$this->isExpired($bannerad) && !$this->isExhausted($bannerad));
	return 0;
}
# Filter viewable ads by status
sub filterByStatus{
	my ($this,$bannerads) = @_;
	my @newbanners;
	# Construct a list consist of active ads
	foreach my $ad(@$bannerads){
		if ($this->isActive($ad)){
			push(@newbanners,$ad);
		}
	}
	return \@newbanners;
}
# Filter viewable ads by format
sub filterByFormat{
	my ($this,$bannerads,$format) = @_;
	if (! $format) { return $bannerads; }
	my @newbanners;
	# Construct a list consisting of ads of the given format
	foreach my $ad(@$bannerads){
	    if (! $ad->{format} || 
		($this->format($ad->{format})->{name} eq $format)) {
		push(@newbanners,$ad);
	    }
	}
	return \@newbanners;
}
# Filter ads by weights
sub filterByWeight{
	my ($this,$bannerads) = @_;
	# Separate ads into:
	# - display_always: weight >= 10
	# - display_random: weight < 10
	my (@display_always,@display_random);
	foreach my $ad(@$bannerads){
		if ($ad->{weight} >= 10){
			push(@display_always,$ad);
		}else{
			# if no weight is specified, the weight is presumed to be 1
			$ad->{weight} = $ad->{weight} || 1;
			push(@display_random,$ad);
		}
	}
	return (\@display_always,\@display_random);
}
# Filter displayed ads
sub filterByDisplayedID{
	my ($this,$bannerads) = @_;
	# Skip the check if no ads are displayed on the page
	return $bannerads if !exists($this->{displayed_id});
	# Get the list of displayed ads from $this->{displayed_id}
	my $idlist = join("|",keys(%{$this->{displayed_id}}));
	my @newlist;
	# Construct a list of ads that has not being displayed on the page
	foreach my $ad(@$bannerads){
		if ($ad->{bannerad_id} !~ /$idlist/){
			push(@newlist,$ad);
		}
	}
	return \@newlist;
}
# Adjust ad's balance
sub adjustBalance{
	# $type: banner ad type
	my ($this,$bannerad,$type) = @_;
	# Only adjust the balance on the ad if it matches the $type
	return if $bannerad->{bannerad_type} !~ /$type/i;
	my $cost = $bannerad->{balance} - $bannerad->{rate};
	$this->{db}->update("bannerad",{balance=>$cost},{bannerad_id=>$bannerad->{bannerad_id}});
	return;
}
# Adjust balance for the pay per view ad
sub adjustBalancePayPerViewAd{
	my ($this,$bannerad) = @_;
	return $this->adjustBalance($bannerad,"pay-per-view");
}
# Adjust balance for the pay per click ad
sub adjustBalancePayPerClickAd{
	my ($this,$bannerad) = @_;
	return $this->adjustBalance($bannerad,"pay-per-click");
}
# Track impression
sub trackImpression{
	my ($this,$bannerad) = @_;
	return if $bannerad->{logging} !~ /on/i;
	if (!$config{BannerAd}{log}{$bannerad->{bannerad_type}}{impression}){
		return;
	}
	my $L = new Modules::BannerAd::Log();
	$L->impression($bannerad->{bannerad_id});
	return;
}
# Track click through
sub trackClick{
	my ($this,$bannerad) = @_;
	return if $bannerad->{logging} !~ /on/i;
	if (!$config{BannerAd}{log}{$bannerad->{bannerad_type}}{click}){
		return;
	}
	my $L = new Modules::BannerAd::Log();
	$L->click($bannerad->{bannerad_id});
	return;
}
sub trackDaily{
	my ($this,$bannerad,$count,$time) = @_;
	return if $bannerad->{logging} !~ /on/i;
	if (!$config{BannerAd}{log}{$bannerad->{bannerad_type}}{'daily impression'}){
		return;
	}
	my $L = new Modules::BannerAd::Log();
	$L->daily($bannerad->{bannerad_id},$count,$time);
	return;
}
# Show banners on the page
sub showBanner{
	my ($this,$bannerad) = @_;
	$this->trackImpression($bannerad);
	# Adjust balance for pay per view ads
	$this->adjustBalancePayPerViewAd($bannerad);
	my $link = "";
	# Click through link
	if ($bannerad->{url}){
		$link = "$config{server}{server}$config{server}{CGIpath}/bannerad.cgi?bannerad_id=$bannerad->{bannerad_id}";
	}
	# get format dimensions
	my %div_attr = (cllass=>"Bannerad");
	if ($bannerad->{format}) {
		my $x = $this->format($bannerad->{format})->{width};
		my $y = $this->format($bannerad->{format})->{height};
		$div_attr{style} = "width:$x; height:$y;";
	}
	my $ml = $this->ml();
	my $out;
	# Use banner image
	if ($bannerad->{fdata}){
		my $image_banner = $this->getBannerHTML($bannerad);
		$out = $link ? $ml->a($image_banner,{href=>$link,target=>"bannerad"}) : $image_banner;
	# Use text
	}else{
		my $text_banner = $link ? $ml->a($bannerad->{adata},{href=>$link,target=>"bannerad"}): $bannerad->{adata};
		$text_banner .= $bannerad->{ddata} ?  $ml->br()."$bannerad->{ddata}" : "";
		$text_banner .= $this->getBannerUrl() ?  $ml->img(undef,{src=>$this->getBannerUrl($bannerad),border=>0,width=>1,height=>1})  : "";
		$out = $ml->div($text_banner,{class=>"BannerAdText"});
	}
	return $ml->div($out,\%div_attr);
}


# Process banner click through
sub processBannerClick{
	my ($this,$banneradid) = @_;
	# Fetch the ad
	my %ad = $this->{db}->fetch("bannerad",$banneradid);
	# Adjust balance for pay per click ad
	$this->adjustBalancePayPerClickAd(\%ad);
	$this->trackClick(\%ad);
	# Fix the ad url
	my $url = ($ad{url} =~ /^http/i ? "" : "http://").$ad{url};
	# Use meta refresh for redirection
	my $ml = $this->ml();
	return "content-type: text/html\n\n".$ml->html($ml->head($ml->meta(undef,{'http-equiv'=>"refresh",content=>"0;url=$url"})).$ml->body(""));
}
# Display banners on the screen
sub displayBanner{
	my ($this,$format,$count) = @_;
	# Skip if the page object doesn't exist
	return "" if !exists($share{Page});
	if ($count < 1) { $count = 1; }
	# Get section_id
	my $sectionid = $share{Page}->id("section");
	# Fetch ads
	my @bannerads = $this->{db}->get_query("active banners",$sectionid);
	# Remove incompatible formats
	@bannerads = @{$this->filterByFormat(\@bannerads,$format)};
	# Remove displayed ads
	@bannerads = @{$this->filterByDisplayedID(\@bannerads)};
	# Remove inactive ads
	@bannerads = @{$this->filterByStatus(\@bannerads)};
	# Separate adds into always displayed ads and randomly displayed ads
	my ($display_always,$display_random) = $this->filterByWeight(\@bannerads);
	my %display_random;
	# Weight total for the random ads
	my $weight_total = 0;
	# Calculate the weight total
	foreach my $ad (@$display_random){
		$display_random{$ad->{bannerad_id}} = $ad;
		$weight_total += $ad->{weight};
	}
	# Put selected banners into @out_banner
	my @out_banner;
	if ($count > @bannerads) { $count = @bannerads; }
	for(my $i = 0; $i < $count; $i++){
		# Always selected ads(weight >= 10)
		if (($i + 1) <= @$display_always){
			# Sort ads by weight then id
			@$display_always = sort{($b->{weight} <=> $a->{weight}) || ($a->{bannerad_id} <=> $b->{bannerad_id})} @$display_always;
			# Select the ads one by one
			for(my $i = 0; $i < $count; $i++){
				# Put the ad into @out_banner
				push(@out_banner,$this->showBanner($display_always->[$i]));
				# Flag the ad as displayed
				$this->{displayed_id}{$display_always->[$i]{bannerad_id}} = 1;
			}
		# Randomly selected ads(weight < 10)
		# 
		# Ad selection is done by choosing the position($ad_position) that 
		# the ad locates on the list($weight_total: total number of positions).
		# The number of positions that an ad may take on the list is determined by its weight.
		#
		}else{
			# Generate a random number
			my $random = int(scalar(@bannerads) * rand(10000));
			# Position of the ad that we are going to select
			my $ad_position = ($random % $weight_total) + 1;
			# Track the ad position.
			my $count = 0;
			# Loop through the hash %display_random
			foreach my $id(keys(%display_random)){
				# Accumulate the counter
				$count  = $count + $display_random{$id}{weight};
				# Once the counter reaches the position($count >= $ad_position), the ad is selected.
				if ($count >= $ad_position){
					push(@out_banner,$this->showBanner($display_random{$id}));
					# Remove the weight of the selected ad from $weight_total
					$weight_total = $weight_total - $display_random{$id}{weight};
					# Remove the ad from the hash
					delete $display_random{$id};
					# Flag the ad as displayed
					$this->{displayed_id}{$id} = 1;
					# Exit the loop
					last;
				}
			}
		}
	}
	return join($config{BannerAd}{join_ads}."\n",@out_banner);
}
#----------------------------------------------------------------------
# Delete confirmation popup
sub javascript{
	my ($this) = @_;
	my $delete_url = $this->link(action=>"delete_bannerad",__plaintext=>1);
	my $out = <<END;
function deleteConfirm(id){
	if (confirm('Are you sure want to delete this record?')){
		location.href = '${delete_url}&bannerad_id=' + id;
	}
}
END
	return $this->ml()->script($out);
}
sub export{
	my ($this,$opt) = @_;
	$this->reportbuilder()->init(%$opt);
 	return $this->reportbuilder()->export("excel");
}
# Build reports using ExSite::ReportBuilder
sub report{
	my ($this,$opt) = @_;
	$this->reportbuilder()->init(%$opt);
	return $this->reportbuilder()->make();
}
# Page redirection
sub redirect{
        my ($this,$reply) = @_;
	ExSite::Util::redirect($reply);
	return;
}
sub reportbuilder{
	return &get_obj("ReportBuilder");;
}
sub ml{
	return &get_obj("ML");
}
sub time{
	return &get_obj("Time");
}
#----------------------------------------------------------------------

sub site_license {
    my ($this,$site) = @_;
    return 0 if (! $share{DB});
    if ($this->ioctl("isRestricted")) {
	# this service requires licenses
	if (!$site && $share{Page}) {
	    $site = $share{Page}->id("section");
	}
	if ($site) {
	    my $licenses = $this->{db}->fetch_match("service",
						    {section_id => $site,
						     name => "BannerAd" }
						    );
	    return (scalar @$licenses > 0);
	}
	# hmm, that's strange, we're not on a page
	return 0;
    }
    # this modules is not a service - anyone can use it
    return 1;
}
#----------------------------------------------------------------------
package Modules::BannerAd::Log;
use strict;
use ExSite::Object;
use base qw (ExSite::Object);
sub my_type{
	return "bannerad_log";
}
sub label{
	my ($this,$key) = @_;
	return $this->DB()->{map}->get_column_attr($this->type(),$key,"label") || "";
}
sub getdata_excel{
	my ($this,$key) = @_;
	my %cmd = (
		"time"=>"getdata",
	);
	my $sub = exists $cmd{$key} ? $cmd{$key} : "showdata";
	return $this->$sub($key);
}
sub add{
	my ($this,$type,$bannerid,$option) = @_;
	return if !$bannerid;
	my $o = $this;
	if ($this->id()){
		$o = $this->new();
	}
	if (ref($option) =~ /hash/i){
		foreach my $key (keys %$option){
			$o->setdata($key,$option->{$key});
		}
	}
	$o->setdata("type",$type);
	$o->setdata("bannerad_id",$bannerid);
	$o->setdata("viewer_ip",$ENV{REMOTE_ADDR});
	$o->setdata("referrer",$ENV{HTTP_REFERER});
	$o->setdata("count",1) if !$o->getdata("count");
	$o->save();
	return;
}
sub impression{
	# $bannerid: banner id
	my ($this,$bannerid) = @_;
	return $this->add("impression",$bannerid);
}
sub click{
	# $bannerid: banner id
	my ($this,$bannerid) = @_;
	return $this->add("click",$bannerid);
}
sub daily{
	# $bannerid: banner id
	# $count: count
	my ($this,$bannerid,$count,$time) = @_;
	return $this->add("daily impression",$bannerid,{count=>$count,time=>$time});
}
1;
