package Modules::Facebook;
use strict;
use ExSite::Config;
use ExSite::Misc;

use Modules::BaseDCD;
use  base qw(Modules::BaseDCD);

# Usage:
# 
# Like button:
# <!--&Facebook(w=like_button&url=<your url>)-->
#	url: url (default to current page).  Full url only
#
# Comments:
# <!--&Facebook(w=comments&url=<your url>&appid=<your facebook application id>)-->
# 	url: url (default to current page).  Full url only (cgi url with query string is not acceptable)
#	appid  facebook application id (optional) To moderate comments, you must provide a facebook application id (http://www.facebook.com/developers/createapp.php)
#
# Recommendations:
# <!--&Facebook(w=recommendations&domain=<your domain>)-->
#	domain: domain (default to current domain).  Must include 'http'
#
# Activity Feed:
# <!--&Facebook(w=activity_feed&domain=<your domain>)-->
#	domain: domain (default to current domain).  Must include 'http'

my %widgets = (
	like_button=>{
		label=>"Like Button",
		option=>"w=like_button",
	},
	comments=>{
		label=>"Comments",
		option=>"w=comments",
	},
	recommendations=>{
		label=>"Recommendations",
		option=>"w=recommendations",
	},
	activity_feed=>{
		label=>"Activity Feed",
		option=>"w=activity_feed",
	},
);
sub ioctl {
	my $this = shift;
	$_ = shift;
	if (/ModuleName/) {
		return "Facebook";
	}elsif (/ModuleInfo/) {
		return "Facebook widgets";
	}elsif (/DynContentParam/){
		return $this->getDynContentParameter(shift);
	}
	return;
}
sub getDynContentParameter{
	my ($this) = @_;
	my $ml = &get_obj("ML");
	my $list_option;
	foreach my $key (keys(%widgets)){
		$list_option .= $ml->option($widgets{$key}{label},{value=>$widgets{$key}{option}});
	}
	return $ml->table($ml->tr($ml->td("Select an option:").$ml->td($ml->select($list_option,{name=>"param"}))));
}
sub write{
	my ($this,$options) = @_;
	my %param = &DecodeString($options);
	my $widget_list = join("|",keys(%widgets));
	my $widget = $param{w};
	if ($widget =~ /^(${widget_list})$/i){
		return $this->js(\%param).$this->$widget(\%param);
	}
	return "";
}
# Like button
sub like_button{
	my ($this,$in) = @_;
	my $url = $in->{url} || $this->current_url();
	return "" if !$url;
	return "<fb:like href=\"$url\"></fb:like>";
}
# Comments
sub comments{
	my ($this,$in) = @_;
	my $url = $in->{url} || $this->current_url();
	return "" if !$url;
	return "<fb:comments xid=\"".&url_escape($url,':/[]+*^$?')."\"></fb:comments>";
}
# Recommendations
sub recommendations{
	my ($this,$in) = @_;
	my $domain = $in->{domain} || $config{server}{server};
	return "<fb:recommendations site=\"$domain\"></fb:recommendations>";
}
# Activity feed
sub activity_feed{
	my ($this,$in) = @_;
	my $domain = $in->{domain} || $config{server}{server};
	return "<fb:activity site=\"$domain\" recommendations=\"false\"></fb:activity>";
}
# Get current page url
sub current_url{
	my ($this) = @_;
	return "" if !$share{Page};
	my $old_rdu = $config{page}{relative_dynamic_url};
	my $old_dut = $config{page}{dyn_url_type};
	$config{page}{relative_dynamic_url} = 0;
	$config{page}{dyn_url_type} = "path";
	my $url = $share{Page}->get_url();
	$config{page}{relative_dynamic_url} = $old_rdu;
	$config{page}{dyn_url_type} = $old_dut;
	return $url;
}
# Facebook Javascript SDK
sub js{
	my $this = shift;
	my $in = shift;
	return "" if $this->{js_loaded};
	$this->{js_loaded} = 1;
	my $appid = $in->{appid} || $config{Facebook}{appid} || "";
	my $out = <<END;
	window.fbAsyncInit = function() {
		FB.init({appId: '$appid',status: true, cookie: true,xfbml: true});
	};
	(function() {
		var e = document.createElement('script'); e.async = true;
		e.src = document.location.protocol +
		'//connect.facebook.net/en_US/all.js';
		document.getElementById('fb-root').appendChild(e);
	}());
END
	my $ml = &get_obj("ML");
	return $ml->div("",{id=>"fb-root"}).$ml->script($out);
}
1;
