#!/usr/bin/perl

package Modules::Zine::IndexTopstory;

use strict;
use ExSite::Config;
use Modules::Zine::Index;

use vars qw(@ISA);
@ISA = qw(Modules::Zine::Index);

sub index {
    my ($this,%opt) = @_;

    # get all the articles in the index
    my @articles = $this->fetch_index(%opt);

    # format the index
    return $this->index_topstory(\%opt,@articles);
}

sub index_topstory {
    my ($this,$opt,@articles) = @_;

    my $format = "full";
    my $ml = &get_obj("ML");

    # save current article
    $this->save;

    # build normal list-like indexes
    my ($index);
    foreach my $art (@articles) {
	$this->set($art);
	$index .= $this->show_item($format);
	if ($format eq "full") {
	    $format = "summary";
	    $index .= $ml->h2($msg{"More Articles:"});
	}
    }

    # reset article
    $this->restore;

    return $index;
}

1;

